﻿using System;
using System.IO;
using System.Linq;
using System.Security.Cryptography;
using System.Text;

namespace TestWeb
{
    public partial class signTest : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if(!IsPostBack)
            {
                string SecretId = "这里输入您的SecretId";//SecretId替换成自己的
                string SecretKey = "这里输入您的SecretKey";//SecretKey替换成自己的

			string domain = "http://{bucket}-{appid}.cos.ap-beijing.myqcloud.com";//把{bucket}  {appid} 都替换成自己的
                string q_sign_algorithm = "sha1";
                string q_ak = SecretId;
                string q_sign_time = GetTimeStamp(DateTime.UtcNow) +";"+ GetTimeStamp(DateTime.UtcNow.AddHours(1));//签名有效期1个小时
                string q_key_time = GetTimeStamp(DateTime.UtcNow) + ";" + GetTimeStamp(DateTime.UtcNow.AddHours(1));//签名有效期1个小时;
                string q_header_list = "";
                string q_url_param_list = "";
                string q_signature = "";

                string key = "/1.jpg";//uri,这里要确保您的bucket根目录有一个名为1.jpg的对象，也可以修改为别的存在的对象
                string method = "get";//请求方式


                string SignKey = ComputeHash(Encoding.ASCII.GetBytes(SecretKey), q_key_time);//对签名的有效起止时间加密计算值SignKey
                string HttpString = method+"\n" + key + "\n\n\n";//根据固定格式组合生成
                string StringToSign = q_sign_algorithm+"\n"+ q_sign_time + "\n"+ GetSH1(HttpString) + "\n";//加密 HttpString，并根据固定格式组合生成 StringToSign
                string Signature = ComputeHash(Encoding.ASCII.GetBytes(SignKey), StringToSign);//加密 StringToSign，生成 Signature

                Response.Write(domain + key+ "?q-sign-algorithm="+ q_sign_algorithm + "&q-ak="+ q_ak + "&q-sign-time="+ q_sign_time + "&q-key-time="+ q_key_time + "&q-header-list=&q-url-param-list=&q-signature="+ Signature);
            }
        }


        /// <summary>
        /// 获取时间戳
        /// </summary>
        /// <returns></returns>
        public static string GetTimeStamp(DateTime dt)
        {
            TimeSpan ts = dt - new DateTime(1970, 1, 1, 0, 0, 0, 0);
            return Convert.ToInt64(ts.TotalSeconds).ToString();
        }
        /// <summary>
        /// 计算哈希
        /// </summary>
        /// <param name="key"></param>
        /// <param name="input"></param>
        /// <returns></returns>
        public static string ComputeHash(byte[] key, string input)
        {
            HMACSHA1 myhmacsha1 = new HMACSHA1(key);
            byte[] byteArray = System.Text.Encoding.ASCII.GetBytes(input);
            MemoryStream stream = new MemoryStream(byteArray);
            return myhmacsha1.ComputeHash(stream).Aggregate("", (s, e) => s + String.Format("{0:x2}", e), s => s);
        }
        /// <summary>
        /// SHA1
        /// </summary>
        /// <param name="value"></param>
        /// <returns></returns>
        public static string GetSH1(string value)
        {
            SHA1 algorithm = SHA1.Create();
            byte[] data = algorithm.ComputeHash(Encoding.UTF8.GetBytes(value));
            string sh1 = "";
            for (int i = 0; i < data.Length; i++)
            {
                sh1 += data[i].ToString("x2").ToLower();
            }
            return sh1;
        }
    }
}